 #include <gnome.h>

GtkWidget * entry;
GtkWidget * check_button;

void button_clicked(GtkWidget * button, gpointer data)
{
        const char * cmdline = gtk_entry_get_text(GTK_ENTRY(entry));
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check_button)))
		gnome_execute_terminal_shell(NULL, cmdline);
	else
		gnome_execute_shell(NULL, cmdline);
 }

gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
        gtk_main_quit();
        return FALSE;
}

int main(int argc, char * argv[])
{
	GnomeProgram * gnome_prog;
        GtkWidget * mainwnd;
        GtkWidget * vbox;
        GtkWidget * hbox;
        GtkWidget * button;
		
	gnome_prog = gnome_program_init("gnomeexec", "0.1", LIBGNOMEUI_MODULE, argc, argv, NULL, NULL);
        mainwnd = gnome_app_new ("gnomeexec",
                             "Запуск приложений из GNOME-программы");
        gtk_signal_connect (GTK_OBJECT (mainwnd), "delete_event",
                            GTK_SIGNAL_FUNC(delete_event), NULL);
        vbox = gtk_vbox_new(FALSE, 2);
        hbox = gtk_hbox_new (FALSE, 5);
        entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX(hbox), entry, TRUE, TRUE, 0);
        button = gtk_button_new_with_label("Запуск");
        gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (button_clicked), 
          NULL);
        gtk_box_pack_start (GTK_BOX(hbox), button, FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
        check_button = gtk_check_button_new_with_label("Запустить в окне терминала");
        gtk_box_pack_start(GTK_BOX(vbox), check_button, FALSE, FALSE, 0);
        gnome_app_set_contents (GNOME_APP (mainwnd), vbox); 
        gtk_widget_show_all(mainwnd);
	gtk_entry_set_activates_default(GTK_ENTRY(entry), TRUE);
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(button);
	gtk_main ();
        return 0;
}
